﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DecodingCodePrufer
{
    internal class MethodCode
    {

        public string Path { get; set; }    
        public MethodCode(string path)
        {
            Path = path;
        }

        private int?[] reading()
        {
            int n = File.ReadAllLines(Path).Length;
            int?[] code = null;
            using (StreamReader reader = new StreamReader(Path))
            {
                for (int i = 0; i < n; i++)
                {
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] { ' ' });
                    code = new int?[mas.Length];
                    for (int j = 0; j < mas.Length; j++)
                    {
                        code[j] = (int.Parse(mas[j]));
                    }

                }

            }
            return code;
        }

        public void Decoding()
        {
            int?[] code = reading();
            List<int> vertices = new List<int>();
            List<List<int>> ribs = new List<List<int>>();

            for(int i = 1; i <= code.Length + 2; i++)
            {
                vertices.Add(i);
            }
            for (int i = 0; i < code.Length; i++)
            {
                
                for (int j = 0; j < vertices.Count; j++)
                {
                    if (!code.Contains(vertices[j]))
                    {
                        ribs.Add(new List<int> { (int)code[i], vertices[j] });
                        code[i] = null;
                        vertices.RemoveAt(j);
                        break;

                    }
                }
            }
            ribs.Add(new List<int> { vertices[0], vertices[1] });
            writing(ribs);

        }

        private void writing(List<List<int>> ribs)
        {
            FileStream file1 = new FileStream("tree.txt", FileMode.OpenOrCreate);
            StreamWriter writer = new StreamWriter(file1);
            writer.WriteLine("Исходный граф: ");
            for (int i = 0; i < ribs.Count; i++)
            {
                for(int j = 0;j < ribs[i].Count; j++)
                {
                    writer.Write(ribs[i][j] + " ");
                }
                writer.Write('\n');
            }
            writer.Close();
        }
    }
}
